<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:rich="http://richfaces.org/rich"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h1>#{messages['net.ihe.gazelle.patientmanager.PredefinedTestData']}</h1>
        <h:form id="globalForm">
            <s:div>
                <!--<s:token allowMultiplePosts="true"/>-->
                <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
                <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                               value="#{testDataListManager.filter.urlParameters}"/>
                <script>
                    updateUrl("globalForm:filterUrlParameters");
                    jq162("#globalForm\\:filterUrlParameters").bind('change',
                        function () {
                            updateUrl("globalForm:filterUrlParameters");
                        });

                </script>
                <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                    <ui:define name="filter_buttons">
                        <a4j:commandLink title="#{messages['net.ihe.gazelle.patientmanager.Refresh']}"
                                         render="tdTable">
                            <span class="fa fa-refresh"></span>
                        </a4j:commandLink>
                        <a4j:commandLink title="#{messages['gazelle.pam.ResetCriteria']}"
                                         actionListener="#{testDataListManager.clean()}"
                                         render="">
                            <span class="fa fa-times-circle"></span>
                        </a4j:commandLink>
                    </ui:define>
                    <div class="row">
                        <div class="col-md-4">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filterWidth" value="240"/>
                                <ui:param name="filter" value="#{testDataListManager.filter}"/>
                                <ui:param name="filterId" value="transaction"/>
                                <ui:param name="filterName" value="#{messages['gazelle.HL7Common.Transaction']}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>
                        </div>
                        <div class="col-md-4">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filterWidth" value="240"/>
                                <ui:param name="filter" value="#{testDataListManager.filter}"/>
                                <ui:param name="filterId" value="modifier"/>
                                <ui:param name="filterName" value="#{messages['gazelle.simulator.pam.Creator']}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>
                        </div>
                        <div class="col-md-4">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filterWidth" value="240"/>
                                <ui:param name="filter" value="#{testDataListManager.filter}"/>
                                <ui:param name="filterId" value="shared"/>
                                <ui:param name="filterName"
                                          value="#{messages['net.ihe.gazelle.patientmanager.Shared']}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>
                        </div>
                    </div>
                </ui:decorate>
                <gri:panel pid="tdPanel">
                    <f:facet name="header">#{messages['net.ihe.gazelle.patientmanager.FilteredTestData']}</f:facet>
                    <rich:dataTable value="#{testDataListManager.getListFiltered()}" var="td" id="tdTable"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                    render="tdTableds">
                        <g:column>
                            <s:span styleClass="gzl-icon-unlock" title="Everybody can use this test data"
                                    rendered="#{td.shared}"/>
                            <s:span styleClass="gzl-icon-lock" title="Only its creator can use this test data"
                                    rendered="#{not td.shared}"/>
                        </g:column>
                        <g:column sortBy="#{'name'}"
                                  sortOrder="#{dataTableStateHolder.sortOrders['name']}"
                                  filterBy="#{'name'}" filterEvent="keyup">
                            <ui:define name="header">#{messages['gazelle.simulator.pam.Name']}</ui:define>
                            <h:outputText value="#{td.name}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.simulators.Description']}</ui:define>
                            <h:outputText value="#{td.description}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.Data']}</ui:define>
                            <ui:include src="/testData/details.xhtml">
                                <ui:param name="currentTD" value="#{td}"/>
                            </ui:include>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.AppliesTo']}</ui:define>
                            <h:outputText value="#{td.applyToTransaction.keyword}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.LastModifiedOn']}</ui:define>
                            <g:date value="#{td.lastModified}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.LastModifiedBy']}</ui:define>
                            <h:outputText value="#{td.lastModifier}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                            <div class="gzl-never-wrap">
                                <a4j:commandLink actionListener="#{testDataListManager.setSelectedTestData(td)}"
                                                 render="confirmDeleteContent"
                                                 oncomplete="jq162('#confirmDelete').modal('show')">
                                    <s:span styleClass="gzl-icon-trash-o"/>
                                </a4j:commandLink>
                            </div>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="tdTableds"/>
                                <ui:param name="dataTableId" value="tdTable"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                    <f:facet name="footer">
                        <div class="btn-group">
                            <button type="button" class="gzl-btn-green dropdown-toggle" data-toggle="dropdown"
                                    aria-haspopup="true" aria-expanded="false">
                                #{messages['net.ihe.gazelle.patientmanager.CreateNewTestDataFor']} <span class="caret"></span>
                            </button>
                            <ul class="dropdown-menu">
                                <li>
                                    <h:outputLink value="#{testDataListManager.createNewTestDataForPDQ()}">#{messages['gazelle.simulator.pam.PDQConsumer']}
                                    </h:outputLink>
                                </li>
                                <li>
                                    <h:outputLink value="#{testDataListManager.createNewTestDataForPDQv3()}">#{messages['net.ihe.gazelle.patientmanager.PDQV3Consumer']}
                                    </h:outputLink>
                                </li>
                                <li>
                                    <h:outputLink value="#{testDataListManager.createNewTestDataForPDQm()}">#{messages['net.ihe.gazelle.patientmanager.PDQmConsumer']}
                                    </h:outputLink>
                                </li>
                                <li>
                                    <h:outputLink value="#{testDataListManager.createNewTestDataForPIXCons()}">#{messages['net.ihe.gazelle.patientmanager.PIXConsumer']}
                                    </h:outputLink>
                                </li>
                                <li>
                                    <h:outputLink value="#{testDataListManager.createNewTestDataForPIXv3Cons()}">#{messages['net.ihe.gazelle.patientmanager.PIXV3Consumer']}
                                    </h:outputLink>
                                </li>
                                <li>
                                    <h:outputLink value="#{testDataListManager.createNewTestDataForPIXm()}">#{messages['net.ihe.gazelle.patientmanager.PIXmConsumer']}
                                    </h:outputLink>
                                </li>
                                <li>
                                    <h:outputLink value="#{testDataListManager.createNewTestDataForXCPD()}">#{messages['net.ihe.gazelle.patientmanager.XCPDInitiatingGateway']}
                                    </h:outputLink>
                                </li>
                            </ul>
                        </div>
                    </f:facet>
                </gri:panel>
            </s:div>
        </h:form>
        <ui:include src="/testData/_confirmDeletePanel.xhtml"/>
    </ui:define>
</ui:composition>